package com.safeway.pricing.safeway.client;

import com.safeway.pricing.safeway.entity.PriceDetails;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Component;
import org.springframework.web.reactive.function.client.WebClient;
import reactor.core.publisher.Flux;

@Component
public class SafewayClient {
    @Value("${client.host}")
    private String clientHost;
    WebClient client = WebClient.create(clientHost);

    public Flux<PriceDetails> getAllPricingDetails() {
        return client.get().uri("/safeway/pricingdetails").accept(MediaType.APPLICATION_JSON).retrieve()
                .bodyToFlux(PriceDetails.class);
    }
}
