package com.safeway.pricing.safeway.config;

import com.safeway.pricing.safeway.entity.PriceDetails;
import com.safeway.pricing.safeway.entity.StoreDetails;
import com.safeway.pricing.safeway.service.PricingService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.reactive.function.server.ServerRequest;
import org.springframework.web.reactive.function.server.ServerResponse;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

import java.time.Duration;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class RouterHandlers {
    @Autowired
    private PricingService pricingService;

    public Mono<ServerResponse> getStoreDetails(ServerRequest serverRequest){
        pricingService.getStoreDetails(serverRequest.pathVariable("storeName"));
        return ServerResponse.ok().body(pricingService.getStoreDetailsMany().asFlux(),StoreDetails.class);
    }


    public Mono<ServerResponse> getPricingDetails(ServerRequest serverRequest){
        return ServerResponse.ok().body(pricingService.getPricingDetails(),PriceDetails.class);
    }

}
