package com.safeway.pricing.safeway.service;

import com.safeway.pricing.safeway.entity.*;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Mono;

import java.util.ArrayList;
import java.util.List;

@Component
public class PricingServiceData {
    List<StoreDetails> storeDetailsList=new ArrayList<>();
    public List<DivisionDetails> getDivisionDetails(){
        List<DivisionDetails> list=new ArrayList<>();
        DivisionDetails divisionDetails=DivisionDetails.builder().divisionId("Div01").division("Hyderabad").city("Madhapur").pinCode(12).build();
        DivisionDetails divisionDetails1=DivisionDetails.builder().divisionId("Div02").division("Hyderabad").city("Kondapur").pinCode(35).build();
        list.add(divisionDetails);
        list.add(divisionDetails1);
        return list;
    }
   public List<SaleDetails> getSaleDetails(){
        SaleDetails saleDetails= SaleDetails.builder().currentVolume(20.9).currentSales(49.0).currentMargin(25).currentProfit(40).currentCPI(12).build();
       SaleDetails saleDetails2= SaleDetails.builder().currentVolume(22.9).currentSales(45.0).currentMargin(27).currentProfit(44).currentCPI(10.9).build();
       List<SaleDetails> list=new ArrayList<>();
       list.add(saleDetails);
       list.add(saleDetails2);
       return list;
    }

    public List<ItemDetails> getItemDetails(){
        List<SaleDetails> saleDetails=getSaleDetails();
        ItemDetails itemDetails= ItemDetails.builder().itemId("Item01").department("Grocery").category("Dairy").subCategory("curd").currentPrice(60).saleDetails(saleDetails.get(0)).build();
        ItemDetails itemDetails2= ItemDetails.builder().itemId("Item02").department("Grocery").category("Dairy").subCategory("Milk").currentPrice(70).saleDetails(saleDetails.get(1)).build();
        List<ItemDetails> itemDetailsList=new ArrayList<>();
        itemDetailsList.add(itemDetails);
        itemDetailsList.add(itemDetails2);
        return itemDetailsList;
    }

    public List<StoreDetails> getStoreDetails(){
        List<DivisionDetails> divisionDetailsList=getDivisionDetails();
        StoreDetails storeDetails= StoreDetails.builder().storeId("Store01").storeName("Vijetha").divisionId(divisionDetailsList.get(0).getDivisionId()).build();
        StoreDetails storeDetails1= StoreDetails.builder().storeId("Store02").storeName("RathnaDeep").divisionId(divisionDetailsList.get(0).getDivisionId()).build();
        StoreDetails storeDetails4=StoreDetails.builder().storeId("Store05").storeName("Vijetha").divisionId(divisionDetailsList.get(0).getDivisionId()).build();
        StoreDetails storeDetails2= StoreDetails.builder().storeId("Store03").storeName("Vijetha").divisionId(divisionDetailsList.get(1).getDivisionId()).build();
        StoreDetails storeDetails3= StoreDetails.builder().storeId("Store04").storeName("RathnaDeep").divisionId(divisionDetailsList.get(1).getDivisionId()).build();
        storeDetailsList.add(storeDetails);
        storeDetailsList.add(storeDetails1);
        storeDetailsList.add(storeDetails2);
        storeDetailsList.add(storeDetails3);
        storeDetailsList.add(storeDetails4);
         return storeDetailsList;
    }

    public Mono<StoreDetails> addStore(StoreDetails storeDetails){
        Boolean flag=storeDetailsList.add(storeDetails);
        if(flag){
           return Mono.just(storeDetails);
        }
        else
        return null ;
    }

    public List<StoreGroup> getStoreGroups(){
        List<StoreDetails> storeDetailsList=getStoreDetails();
        StoreGroup storeGroup= StoreGroup.builder().storeGroupId("StoreGrp01").storeDetailsList(storeDetailsList).build();
        StoreGroup storeGroup1=StoreGroup.builder().storeGroupId("StoreGrp02").storeDetailsList(storeDetailsList).build();
        List<StoreGroup> storeGroupList=new ArrayList<>();
        storeGroupList.add(storeGroup);
        storeGroupList.add(storeGroup1);
        return storeGroupList;
    }

    public List<PriceArea> getPriceAreas(){
        List<DivisionDetails> list=getDivisionDetails();
        List<StoreGroup> storeGroupList=getStoreGroups();
        List<String> storeGroupIds=new ArrayList<>();
        storeGroupIds.add(storeGroupList.get(0).getStoreGroupId());
        storeGroupIds.add(storeGroupList.get(1).getStoreGroupId());
        PriceArea priceArea= PriceArea.builder().priceAreaId("PriceArea01").divisionDetails(list.get(0)).price(1000).storeGroupId(storeGroupIds).build();
        PriceArea priceArea1= PriceArea.builder().priceAreaId("PriceArea02").divisionDetails(list.get(1)).price(700).storeGroupId(storeGroupIds).build();
        List<PriceArea>  priceAreaList=new ArrayList<>();
        priceAreaList.add(priceArea1);
        priceAreaList.add(priceArea);
        return priceAreaList;

    }

    public List<PriceDetails> getPriceDetails(){
        List<SaleDetails> saleDetails=getSaleDetails();
        List<ItemDetails> itemDetailsList=getItemDetails();
        PriceDetails priceDetails=PriceDetails.builder().itemDetailsList(itemDetailsList).saleDetails(saleDetails.get(0)).build();
        PriceDetails priceDetails1=PriceDetails.builder().itemDetailsList(itemDetailsList).saleDetails(saleDetails.get(1)).build();
        List<PriceDetails> priceDetails2=new ArrayList<>();
        priceDetails2.add(priceDetails);
        priceDetails2.add(priceDetails1);
        return priceDetails2;
    }

    public PriceAreaDetails getPriceAreaDetails(){
        List<PriceArea> priceAreaList=getPriceAreas();
        PriceAreaDetails priceAreaDetails=PriceAreaDetails.builder().priceAreas(priceAreaList).build();
        return priceAreaDetails;
    }


}
